// ALDAS.cpp : Defines the class behaviors for the theApplication.

#include "stdafx.h" 
#include <afxtempl.h>

#include "aldas.h"


#include "message.h"
#include "dspcard.h"
#include "llcard.h"

#include "module.h"
#include "hal.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "PlaceDoc.h"
#include "ALDASDoc.h"
#include "ALDASView.h"
#include "CollectDataDoc.h"
#include "CollectDataView.h"
#include "Data.h"
#include "Axis.h"
#include "ScanDoc.h"
#include "ScanView.h"

#include "StrobeScanDoc.h"
#include "StrobeScanView.h"
#include "NoiseScanDoc.h"
#include "NoiseScanView.h"
#include "ThresholdScanDoc.h"
#include "ThresholdScanView.h"
#include "CalibrationScanDoc.h"
#include "CalibrationScanView.h"
#include "ChargeScanDoc.h"
#include "ChargeScanView.h"
#include "DelayScanDoc.h"
#include "DelayScanView.h"
#include "SelectDspDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CALDASApp

BEGIN_MESSAGE_MAP(CALDASApp, CWinApp)
	//{{AFX_MSG_MAP(CALDASApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_THRESHOLD_SCAN, OnNewThresholdScan)
	ON_COMMAND(ID_NOISE_SCAN, OnNewNoiseScan)
	ON_COMMAND(ID_CALIBRATION_SCAN, OnNewCalibrationScan)
	ON_COMMAND(ID_STROBE_SCAN, OnNewStrobedelayscan)
	ON_COMMAND(ID_VREF_SCAN, OnNewVrefscan)
	ON_COMMAND(ID_COLLECT_DATA, OnNewCollectdata)
	ON_BN_CLICKED(IDC_LLCARD, OnLlcard)
	ON_UPDATE_COMMAND_UI(ID_NOISE_SCAN, OnUpdateNoiseScan)
	ON_UPDATE_COMMAND_UI(ID_CALIBRATION_SCAN, OnUpdateCalibrationScan)
	ON_UPDATE_COMMAND_UI(ID_COLLECT_DATA, OnUpdateCollectData)
	ON_UPDATE_COMMAND_UI(ID_THRESHOLD_SCAN, OnUpdateThresholdScan)
	ON_UPDATE_COMMAND_UI(ID_STROBE_SCAN, OnUpdateStrobeScan)
	ON_UPDATE_COMMAND_UI(ID_VREF_SCAN, OnUpdateVrefScan)
	ON_COMMAND(ID_CHARGE_SCAN, OnChargeScan)
	ON_UPDATE_COMMAND_UI(ID_CHARGE_SCAN, OnUpdateChargeScan)
	ON_COMMAND(ID_DELAYSCAN, OnDelayScan)
	ON_UPDATE_COMMAND_UI(ID_DELAYSCAN, OnUpdateDelayScan)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

// CALDASApp construction

CALDASApp::CALDASApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

CALDASApp::~CALDASApp() {
	WriteProfileInt("Messages", "Mode", mDisplayMessages);

	WriteProfileString("Configuration", "File", config_file);

	WriteProfileString("Control blocks", "HacReset", cbHacReset);
	WriteProfileString("Control blocks", "CalAll", cbCalAll);
	WriteProfileString("Control blocks", "Noise", cbNoise);
	WriteProfileString("Control blocks", "HacTP", cbHacTP);
	WriteProfileString("Control blocks", "Path", cbPath);

}
// The one and only CALDASApp object

CALDASApp theApp;

// CALDASApp initialization

BOOL CALDASApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the theApplication's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_ALDAS_TYPE,
		RUNTIME_CLASS(CALDASDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CALDASView));
	AddDocTemplate(pDocTemplate);

	CMultiDocTemplate* pDocTemplate2; //Collect Data document
	pDocTemplate2 = new CMultiDocTemplate( 
		IDR_COLLECTDATA,
		RUNTIME_CLASS(CCollectDataDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CCollectDataView));
	AddDocTemplate(pDocTemplate2);

	CMultiDocTemplate* pDocTemplate4; // strobe scan document
	pDocTemplate4 = new CMultiDocTemplate( 
		IDR_STROBEDELAYSCAN,
		RUNTIME_CLASS(CStrobeScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CStrobeScanView));
	AddDocTemplate(pDocTemplate4);


	CMultiDocTemplate* pDocTemplate1; // noise scan document
	pDocTemplate1 = new CMultiDocTemplate( 
		IDR_NOISESCAN,
		RUNTIME_CLASS(CNoiseScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CNoiseScanView));
	AddDocTemplate(pDocTemplate1);

	CMultiDocTemplate* pDocTemplate3; // threshold scan document
	pDocTemplate3 = new CMultiDocTemplate( 
		IDR_THRESHOLDSCAN,
		RUNTIME_CLASS(CThresholdScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CThresholdScanView));
	AddDocTemplate(pDocTemplate3);

	CMultiDocTemplate* pDocTemplate5; // calbration scan document
	pDocTemplate5 = new CMultiDocTemplate( 
		IDR_CALIBRATIONSCAN,
		RUNTIME_CLASS(CCalibrationScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CCalibrationScanView));
	AddDocTemplate(pDocTemplate5);

	CMultiDocTemplate* pDocTemplate6; // Charge scan document
	pDocTemplate6 = new CMultiDocTemplate( 
		IDR_CHARGESCAN,
		RUNTIME_CLASS(CChargeScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CChargeScanView));
	AddDocTemplate(pDocTemplate6);

	CMultiDocTemplate* pDocTemplate7; // Delay scan document
	pDocTemplate7 = new CMultiDocTemplate( 
		IDR_DELAYSCAN,
		RUNTIME_CLASS(CDelayScanDoc),   
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDelayScanView));
	AddDocTemplate(pDocTemplate7);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	//if (!ProcessShellCommand(cmdInfo)) return FALSE;

	mDisplayMessages = GetProfileInt("Messages", "Mode", 0);

	config_file = GetProfileString("Configuration", "File");
	if (config_file.IsEmpty()) config_file.Format ("Aldas1.ald");

	cbHacReset = GetProfileString("Control blocks", "HacReset");
	if (cbHacReset.IsEmpty()) cbHacReset.Format ("cb\\hac_rese.cb");
	cbCalAll = GetProfileString("Control blocks", "CalAll");
	if (cbCalAll.IsEmpty()) cbCalAll.Format ("cb\\Cal_All.cb");
	cbNoise = GetProfileString("Control blocks", "Noise");
	if (cbNoise.IsEmpty()) cbNoise.Format ("cb\\Noise.cb");
	cbHacTP = GetProfileString("Control blocks", "HacTP");
	if (cbHacTP.IsEmpty()) cbHacTP.Format ("cb\\HacRese.cb");
	cbPath = GetProfileString("Control blocks", "Path");
	if (cbPath.IsEmpty()) cbPath.Format ("c:\\aldas");
#ifdef _DEBUG
	if (cbPath.IsEmpty()) cbPath.Format ("c:\\progra~1\\devstudio\\myprojects\\aldas");
#endif
	OpenNewDocument ("ALDAS", config_file);

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

// CAboutDlg dialog used for theApp About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// theApp command to run the dialog
void CALDASApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


void CALDASApp::OnNewThresholdScan() 
{
	OpenNewDocument ("ThresholdScan", NULL); // string is defined in the string table resource	
}

void CALDASApp::OnChargeScan() 
{
	OpenNewDocument ("ChargeScan", NULL); // string is defined in the string table resource
}

void CALDASApp::OnNewNoiseScan() 
{
	OpenNewDocument ("NoiseScan", NULL); // string is defined in the string table resource
}

void CALDASApp::OnNewCalibrationScan() 
{
	OpenNewDocument ("CalibrationScan", NULL); // string is defined in the string table resource
}

void CALDASApp::OnNewStrobedelayscan() 
{
	OpenNewDocument ("StrobeDelayScan", NULL); // string is defined in the string table resource
}

void CALDASApp::OnNewVrefscan() 
{
	OpenNewDocument ("VrefScan", NULL); // string is defined in the string table resource
}

void CALDASApp::OnNewCollectdata() 
{
	OpenNewDocument ("CollectData", NULL); // string is defined in the string table resource
}

void CALDASApp::OnDelayScan() 
{
	OpenNewDocument ("DelayScan", NULL); // string is defined in the string table resource	
}

BOOL CALDASApp::OpenNewDocument(const CString& type, LPCTSTR fname)
{ // from the book "Inside Vsual C++", this searches for the right document template.
  // the type strings are defined in the string table resource.
	
	CDocTemplate* pSelectedTemplate;
	pSelectedTemplate=GetDocTemplate(type);
	if (pSelectedTemplate) {
		pSelectedTemplate->OpenDocumentFile(fname);
		return TRUE;
	} else {
		return FALSE;
	}
}


CDocTemplate* CALDASApp::GetDocTemplate(const CString& name)
{// from the book "Inside Vsual C++", this searches for the right document template.
  // the type strings are defined in the string table resource.
	CString DocName;
	CDocTemplate* pSelectedTemplate;
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos!=NULL) {
		pSelectedTemplate = (CDocTemplate*) GetNextDocTemplate(pos);
		ASSERT (pSelectedTemplate!=NULL);
		ASSERT (pSelectedTemplate->IsKindOf(RUNTIME_CLASS(CDocTemplate)));
		pSelectedTemplate->GetDocString(DocName, CDocTemplate::docName);
		if (DocName == name) {
			return pSelectedTemplate;
		}
	}
	return NULL;
}

void CALDASApp::OnLlcard() 
{
	// TODO: Add your control notification handler code here
	
}

void CALDASApp::OnUpdateNoiseScan(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateCalibrationScan(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
//	pCmdUI->Enable(FALSE);
}

void CALDASApp::OnUpdateCollectData(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateThresholdScan(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateChargeScan(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateStrobeScan(CCmdUI* pCmdUI) {
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateVrefScan(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(IsModuleActive());
}

void CALDASApp::OnUpdateDelayScan(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(IsModuleActive());	
}

int CALDASApp::IsModuleActive() {
	CDocTemplate* templ=theApp.GetDocTemplate("ALDAS");
	POSITION docPos=templ->GetFirstDocPosition();
	if (!docPos) return FALSE;

	CALDASDoc* mainDoc=(CALDASDoc*)templ->GetNextDoc(docPos);
	HAL * h = mainDoc->GetHal();
	return h->IsModuleActive();
}

HAL * CALDASApp::GetHal() {
	CDocTemplate* templ=theApp.GetDocTemplate("ALDAS");
	POSITION docPos=templ->GetFirstDocPosition();
//	if (!docPos) return FALSE;

	CALDASDoc* mainDoc=(CALDASDoc*)templ->GetNextDoc(docPos);
	return mainDoc->GetHal();
}

