// LLDialog.cpp : implementation file
#include <iostream.h>
#include "stdafx.h"
#include <afxtempl.h>

#include "ALDAS.h"
#include "message.h"
#include "llcard.h"
#include "dspcard.h"
#include "LLDialog.h"
//#include "HybridDlg.h"
//#include "Hybrid.h"


#include "CBExecuteDlg.h"
#include "ModuleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CLLDialog dialog
extern CALDASApp theApp;

CLLDialog::CLLDialog(CWnd* pParent /*=NULL*/, LLCard * theCard/*=NULL*/)
	: CDialog(CLLDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLLDialog)
	mThreshold1 = 0.0f;
	mThreshold2 = 0.0f;
	mThreshold3 = 0.0f;
	mThreshold4 = 0.0f;
	mfileName0 = _T("");
	mfileName1 = _T("");
	mfileName2 = _T("");
	mfileName3 = _T("");
	mStrobeDelay = 0;
	mCounter = 0;
	//}}AFX_DATA_INIT
//	HAL * hal = theApp.GetHal();
	thisCard = theCard;
	mNumReps = 1;
}


void CLLDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLLDialog)
	DDX_Text(pDX, IDC_THRESHOLD1, mThreshold1);
	DDV_MinMaxFloat(pDX, mThreshold1, 0.f, 2.5f);
	DDX_Text(pDX, IDC_THRESHOLD2, mThreshold2);
	DDV_MinMaxFloat(pDX, mThreshold2, 0.f, 2.5f);
	DDX_Text(pDX, IDC_THRESHOLD3, mThreshold3);
	DDV_MinMaxFloat(pDX, mThreshold3, 0.f, 2.5f);
	DDX_Text(pDX, IDC_THRESHOLD4, mThreshold4);
	DDV_MinMaxFloat(pDX, mThreshold4, 0.f, 2.5f);
	DDX_Text(pDX, IDC_FIFO1, mfileName1);
	DDV_MaxChars(pDX, mfileName1, 80);
	DDX_Text(pDX, IDC_FIFO2, mfileName2);
	DDV_MaxChars(pDX, mfileName2, 80);
	DDX_Text(pDX, IDC_FIFO3, mfileName3);
	DDV_MaxChars(pDX, mfileName3, 80);
	DDX_Text(pDX, IDC_STROBE_DELAY, mStrobeDelay);
	DDV_MinMaxUInt(pDX, mStrobeDelay, 0, 255);
	DDX_Text(pDX, IDC_FIFO0, mfileName0);
	DDV_MaxChars(pDX, mfileName0, 80);
	DDX_Text(pDX, IDC_COUNTER, mCounter);
	DDV_MinMaxInt(pDX, mCounter, 0, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLLDialog, CDialog)
	//{{AFX_MSG_MAP(CLLDialog)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_LOAD_FIFO0, IDC_LOAD_FIFO3, OnLoadFifo)
	ON_COMMAND_RANGE(IDC_EXECUTE_FIFO0, IDC_EXECUTE_FIFO3, OnExecuteFifo)
	ON_COMMAND_RANGE(IDC_MODULE0, IDC_MODULE3, OnModule)
END_MESSAGE_MAP()

// CLLDialog message handlers

afx_msg void CLLDialog::OnLoadFifo(UINT nID)
{
	CFileDialog thisDialog(TRUE, ".cb");
	int fifoNumber = nID - IDC_LOAD_FIFO0;
	if (thisDialog.DoModal() != IDOK)
		return;
	else {
		CString filename = thisDialog.GetFileName();
		SetDlgItemText(IDC_FIFO0 + fifoNumber, filename);
		CString pathname = thisDialog.GetPathName();
	// TODO: Add your control notification handler code here
		thisCard->LoadControlBlock(fifoNumber, pathname);

		// re-enable the execute button.
		GetDlgItem (IDC_EXECUTE_FIFO0 + fifoNumber)->EnableWindow(TRUE);
		GetDlgItem (IDC_FIFO0 + fifoNumber)->EnableWindow(TRUE);

	}
}

afx_msg void CLLDialog::OnExecuteFifo(UINT nID) 
{
	int fifoNumber = nID - IDC_EXECUTE_FIFO0;

	CCBExecuteDlg dlg;
	dlg.llCard = thisCard;
	dlg.fifo = fifoNumber;
	dlg.numreps=1;
	dlg.DoModal();
}


BOOL CLLDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	mfileName0 = thisCard->GetControlBlock(0);
	mfileName1 = thisCard->GetControlBlock(1);
	mfileName2 = thisCard->GetControlBlock(2);
	mfileName3 = thisCard->GetControlBlock(3);

	if (mfileName0.IsEmpty()){
		GetDlgItem (IDC_EXECUTE_FIFO0)->EnableWindow(FALSE);
		GetDlgItem (IDC_FIFO0)->EnableWindow(FALSE);
	}
	if (mfileName1.IsEmpty()){
		GetDlgItem (IDC_EXECUTE_FIFO1)->EnableWindow(FALSE);
		GetDlgItem (IDC_FIFO1)->EnableWindow(FALSE);
	}
	if (mfileName2.IsEmpty()){
		GetDlgItem (IDC_EXECUTE_FIFO2)->EnableWindow(FALSE);
		GetDlgItem (IDC_FIFO2)->EnableWindow(FALSE);
	}
	if (mfileName3.IsEmpty()){
		GetDlgItem (IDC_EXECUTE_FIFO3)->EnableWindow(FALSE);
		GetDlgItem (IDC_FIFO3)->EnableWindow(FALSE);
	}

	if (!thisCard->GetModule (0)) {
		GetDlgItem (IDC_MODULE0)->EnableWindow(FALSE);
	}
	if (!thisCard->GetModule (1)) {
		GetDlgItem (IDC_MODULE1)->EnableWindow(FALSE);
	}
	if (!thisCard->GetModule (2)) {
		GetDlgItem (IDC_MODULE2)->EnableWindow(FALSE);
	}
	if (!thisCard->GetModule (3)) {
		GetDlgItem (IDC_MODULE3)->EnableWindow(FALSE);
	}

	// TODO: Add extra initialization here
	char s[40];
	CString newfn(s);

	newfn = remove_path(LPCTSTR(mfileName0));
	mfileName0 = newfn;

	newfn = remove_path(LPCTSTR(mfileName1));
	mfileName1 = newfn;

	newfn = remove_path(LPCTSTR(mfileName2));
	mfileName2 = newfn;

	newfn = remove_path(LPCTSTR(mfileName3));
	mfileName3 = newfn;

	mThreshold1 = thisCard->GetLLDACVoltage(2);
	mThreshold2 = thisCard->GetLLDACVoltage(3);
	mThreshold3 = thisCard->GetLLDACVoltage(0);
	mThreshold4 = thisCard->GetLLDACVoltage(1);

	mStrobeDelay = thisCard->GetStrobeDelay();

	mCounter = thisCard->GetCounter();

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


afx_msg void CLLDialog::OnModule(UINT nID) 
{
	int moduleNumber = nID - IDC_HYBRID0;
	Module * m=thisCard->GetModule (moduleNumber);

	ModuleDlg dlg(this, m);
	dlg.DoModal();
}

CString CLLDialog::remove_path(const char * mystring) {
  const char * cur = mystring;
  char t[40];
  int i = 0;

  while (*cur != '\0') {
    if (*cur == '\\' || *cur == ':')
      i = 0;
    else             // Else copy this character and increment the ptrs.
      t[i++] = *cur;
    cur++;
  }
  t[i] = '\0';

  CString cs(t);
  return cs;
}

void CLLDialog::OnOK() 
{
	UpdateData();

	// Link 0 corresponds to mThreshold3, etc.
	thisCard->SetLLDACVoltage(2, mThreshold1);
	thisCard->SetLLDACVoltage(3, mThreshold2);
	thisCard->SetLLDACVoltage(0, mThreshold3);
	thisCard->SetLLDACVoltage(1, mThreshold4);

	thisCard->SetStrobeDelay(mStrobeDelay);
	thisCard->SetCounterValue(mCounter);
	
	CDialog::OnOK();
}
