// MessageDlg.cpp : implementation file
//
#include "stdafx.h"

#include "ALDAS.h"
#include "MessageDlg.h"
#include "message.h"


extern CALDASApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMessageDlg dialog


CMessageDlg::CMessageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMessageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMessageDlg)
	disable_dialog_box = FALSE;
	//}}AFX_DATA_INIT
}


void CMessageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMessageDlg)
	DDX_Control(pDX, IDC_ERROR, error);
	DDX_Control(pDX, IDC_LINK, link);
	DDX_Control(pDX, IDC_DSP, dsp);
	DDX_Control(pDX, IDC_IDENTIFIER, identifier);
	DDX_Control(pDX, IDC_PARAMETERS, box);
	DDX_Check(pDX, IDC_CHECK1, disable_dialog_box);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMessageDlg, CDialog)
	//{{AFX_MSG_MAP(CMessageDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CHECK1, OnDisableDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessageDlg message handlers




BOOL CMessageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int i, imax;
	char buf[80]; 
	//CEdit id;

	switch (base[0]) {
		//////////////// general messages //////////////////////
	case 16: 
		sprintf(buf, "%3d: Calibrate", base[0]); break;
	case 3:
		sprintf(buf, "%3d: Disable readout", base[0]); break;
	case 4:
		sprintf(buf, "%3d: Enable readout", base[0]); break;
	case 19:
		sprintf(buf, "%3d: Echo", base[0]); break;
	case 21:
		sprintf(buf, "%3d: Get DSP status", base[0]); break;
	case 1:
		sprintf(buf, "%3d: Initialize", base[0]); break;
	case 15:
		sprintf(buf, "%3d: Load data", base[0]); break;
	case 12:
		sprintf(buf, "%3d: Load graycode pattern", base[0]); break;
	case 20:
		sprintf(buf, "%3d: Message test", base[0]); break;
	case 11:
		sprintf(buf, "%3d: Select align delay", base[0]); break;
	case 17:
		sprintf(buf, "%3d: Select run mode", base[0]); break;
	case 18:
		sprintf(buf, "%3d: Select time parameter", base[0]); break;
	case 5:
		sprintf(buf, "%3d: Select trigger mode", base[0]); break;
	case 9:
		sprintf(buf, "%3d: Set DAC", base[0]); break;
	case 6:
		sprintf(buf, "%3d: Transfer data", base[0]); break;
	case 22:
		sprintf(buf, "%3d: Validate data", base[0]); break;
	case 23:
		sprintf(buf, "%3d: Change TCC Clock Speed", base[0]); break;
	case 24:
		sprintf(buf, "%3d: Get TCC Status", base[0]); break;
	case 25:
		sprintf(buf, "%3d: Get external triggers", base[0]); break;
	case 26:
		sprintf(buf, "%3d: Generate internal triggers", base[0]); break;

		////////////// strip messages ///////////////////
	case 212:
		sprintf(buf, "%3d: Dis-Enable link", base[0]); break;
	case 201:
		sprintf(buf, "%3d: Execute control block", base[0]); break;
	case 202:
		sprintf(buf, "%3d: Get detector status", base[0]); break;
	case 207:
		sprintf(buf, "%3d: Get low level status", base[0]); break;
	case 200:
		sprintf(buf, "%3d: Load control block", base[0]); break;
	case 209:
		sprintf(buf, "%3d: Load and execute cotroll block", base[0]); break;
	case 211:
		sprintf(buf, "%3d: Reset FIFOs", base[0]); break;
	case 204:
		sprintf(buf, "%3d: Set strobe delay", base[0]); break;
	case 205:
		sprintf(buf, "%3d: Set counter value", base[0]); break;
	case 206:
		sprintf(buf, "%3d: Set low level DAC", base[0]); break;
	case 210:
		sprintf(buf, "%3d: Set time out", base[0]); break;
	case 203:
		sprintf(buf, "%3d: Detector status", base[0]); break;
	case 208:
		sprintf(buf, "%3d: Low level status", base[0]); break;
	case 51:
		sprintf(buf, "%3d: Data summary", base[0]); break;
	case 50:
		sprintf(buf, "%3d: Data transfer", base[0]); break;
	case 57:
		sprintf(buf, "%3d: DSP Status", base[0]); break;
	case 58:
		sprintf(buf, "%3d: TCC Status", base[0]); break;
	case 55:
		sprintf(buf, "%3d: Echo reply", base[0]); break;
	case 56:
		sprintf(buf, "%3d: Test message", base[0]); break;
	case 81:
		sprintf(buf, "%3d: Error report", base[0]); break;
	case 80:
		sprintf(buf, "%3d: Fatal error", base[0]); break;
	case 53:
		sprintf(buf, "%3d: Response", base[0]); break;

	default :
		sprintf(buf, "%3d: (Unknown message)", base[0]); break;
	} // switch (base[0])


	identifier.SetWindowText(buf);
	sprintf(buf, "%d", base[2]);
	dsp.SetWindowText(buf);
	sprintf(buf, "%d", base[4]);
	link.SetWindowText(buf);

	sprintf(buf, "%3i: Identifier:\t%10d \t0x%08x", 0, base[0], base[0]);
	box.AddString (buf);
	sprintf(buf, "%3i: Length:    \t%10d \t0x%08x", 1, base[1], base[1]);
	box.AddString (buf);
	sprintf(buf, "%3i: DSP number:\t%10d \t0x%08x", 2, base[2], base[2]);
	box.AddString (buf);
	sprintf(buf, "%3i: Dip switch:\t%10d \t0x%08x", 3, base[3], base[3]);
	box.AddString (buf);
	sprintf(buf, "%3i: Link:      \t%10d \t0x%08x", 4, base[4], base[4]);
	box.AddString (buf);
	sprintf(buf, "%3i: Host CIW:  \t%10d \t0x%08x", 5, base[5], base[5]);
	box.AddString (buf);
	
	for (i=6; i<11; i++) {
		sprintf(buf, "%3i: Spare:     \t%10d \t0x%08x", i, base[i], base[i]);
		box.AddString (buf);
	}

	box.AddString ("-------------------------------------------------------");

	imax=base[1];
	if (imax>2048) imax = 2048; // in case that base[1] is not a valid length.
	for (i=11; i<imax; i++) {
		sprintf(buf, "%3i: Parameter: \t%10d \t0x%08x", i, base[i], base[i]);
		box.AddString (buf);
	}

	

	if ((base[0]==80)||(base[0]==81)) { // error messages
		switch (base[11]) {
		//////////////// error messages //////////////////////
		case 1: 
			sprintf(buf, "%3d: No Low Level Card", base[11]); break;		
		case 2: 
			sprintf(buf, "%3d: No High Level Card", base[11]); break;		
		case 3: 
			sprintf(buf, "%3d: Read out Error", base[11]); break;		
		case 4: 
			sprintf(buf, "%3d: Memory Overflow", base[11]); break;		
		case 5: 
			sprintf(buf, "%3d: Invalid Runmode", base[11]); break;		
		case 6: 
			sprintf(buf, "%3d: Invalid AL delay", base[11]); break;		
		case 7: 
			sprintf(buf, "%3d: Graycode too long", base[11]); break;		
		case 8: 
			sprintf(buf, "%3d: Invalid link", base[11]); break;		
		case 9: 
			sprintf(buf, "%3d: Command unknown", base[11]); break;		
		case 10: 
			sprintf(buf, "%3d: Format unknown", base[11]); break;		
		case 11: 
			sprintf(buf, "%3d: Message too long", base[11]); break;		
/* other errors:     reported by message error_report                 */
		case 50: 
			sprintf(buf, "%3d: Invalid DAC value", base[11]); break;		
		case 51: 
			sprintf(buf, "%3d: Invalid destination DAC", base[11]); break;		
		case 52: 
			sprintf(buf, "%3d: Trigger error", base[11]); break;		
		case 53: 
			sprintf(buf, "%3d: No detector data", base[11]); break;		
		case 54: 
			sprintf(buf, "%3d: No trigger data", base[11]); break;		
		case 55: 
			sprintf(buf, "%3d: No data", base[11]); break;		


		default :
			sprintf(buf, "%3d: (Unknown error)", base[11]); break;
		} // switch (base[11])
	} else 		if (base[0]==53) { //  response
		switch (base[11]) {
		
		case 0: 
			sprintf(buf, "Response: Done", base[11]); break;		
		case 1: 
			sprintf(buf, "Response: Accepted", base[11]); break;		
		case 2: 
			sprintf(buf, "Response: Refused", base[11]); break;	
		default :
			sprintf(buf, "%3d: (Unknown Response)", base[11]); break;
		} // switch (base[11])	
	} else {
		sprintf(buf, "(No error)");
	}
	error.SetWindowText(buf);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMessageDlg::OnDisableDialog()
{
	theApp.mDisplayMessages++;
}
