// NoiseFitDlg.cpp : implementation file
//

#include "stdafx.h"
#include <math.h>
#include "ALDAS.h"
#include "Axis.h"
#include "NoiseFitDlg.h"
#include "FitFunction.h"

//typedef float (CNoiseFitDlg::*PtrToLineFunc) (float);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNoiseFitDlg dialog


CNoiseFitDlg::CNoiseFitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNoiseFitDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNoiseFitDlg)
	channelNumber = 0;
	badChannelCheck = FALSE;
	//}}AFX_DATA_INIT
	boxTitle.Empty();
}

CNoiseFitDlg::~CNoiseFitDlg() {
}

void CNoiseFitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNoiseFitDlg)
	DDX_Text(pDX, IDC_CHANNEL, channelNumber);
	DDX_Check(pDX, IDC_BAD_CHANNEL, badChannelCheck);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNoiseFitDlg, CDialog)
	//{{AFX_MSG_MAP(CNoiseFitDlg)
	ON_BN_CLICKED(IDC_BAD_CHANNEL, OnBadChannel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoiseFitDlg message handlers

BOOL CNoiseFitDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString buf;
	char pm=177; // plus/minus char
	
	buf.Format("%i", channelNumber);
	SetDlgItemText(IDC_CHANNEL,  buf);
	buf.Format("%6.2f", axis1->GetChiSquare()[channelNumber]);
	SetDlgItemText(IDC_CHISQ,  buf);
	buf.Format("%s:", axis1->GetLabel());
	SetDlgItemText(IDC_LABEL1,  buf);
	buf.Format("%s:", axis2->GetLabel());
	SetDlgItemText(IDC_LABEL2,  buf);
	buf.Format("%f %c %f", axis1->GetData()[channelNumber], pm, axis1->GetError()[channelNumber]);
	SetDlgItemText(IDC_PAR1,  buf);
	buf.Format("%f %c %f", axis2->GetData()[channelNumber], pm, axis2->GetError()[channelNumber]);
	SetDlgItemText(IDC_PAR2,  buf);

	if (boxTitle) SetWindowText(boxTitle);

	graph.SubclassDlgItem (IDC_GRAPH, this);
	graph.Init(xAxis, yAxis, func);

	badChannelCheck = badChannel[channelNumber];

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNoiseFitDlg::Init(CAxis* a1, CAxis* a2, int ch, BOOL* bad, CAxis* x, CAxis* y, CFitFunction* f)
{
	axis1=a1; // used to display data[channel] in text box
	axis2=a2; // used to display data[channel] in text box
	xAxis=x; //plotted horizontally
	yAxis=y; // plotted vertically
	badChannel=bad;
	channelNumber=ch;
	func = f;
}

void CNoiseFitDlg::OnBadChannel() 
{
	badChannel[channelNumber] = IsDlgButtonChecked(IDC_BAD_CHANNEL);
}
