// CCalibrationScanDoc.h

#include "..\Axis.h"	// Added by ClassView
class CData;
class Hybrid;

class CCalibrationScanDoc : public CScanDoc
{
friend class CCalibrationScanView;

protected: // create from serialization only
	CCalibrationScanDoc();
	DECLARE_DYNCREATE(CCalibrationScanDoc)

// Attributes
public:
	BOOL calLine[4];
	float thrInc;
	float thrMax;
	float thrMin;
	float calInc;
	float calMax;
	float calMin;
	int calPoints;
	int thrPoints;
	CAxis* response;
	float* mean;
	float* meanErr;
	float* thr; // stores thr values
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCollectDataDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	float Volt2Charge(float volt);
	CAxis threshold;
	virtual ~CCalibrationScanDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CCalibrationScanDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	float coeff[3];
	void AnalyzeData();
};