// CollectDataView.cpp : implementation of the CCollectDataView class
//

#include "stdafx.h"
#include "ALDAS.h"
#include <math.h>
#include "MainFrm.h"

#include "PlaceDoc.h"
#include "CollectDataDoc.h"
#include "CollectDataView.h"
#include "HeadingDlg.h"
#include "ChannelDlg.h"
#include "Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CCollectDataView

IMPLEMENT_DYNCREATE(CCollectDataView, CScrollView)

BEGIN_MESSAGE_MAP(CCollectDataView, CScrollView)
	//{{AFX_MSG_MAP(CCollectDataView)
	ON_COMMAND(ID_SETHEADING, OnSetheading)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CCollectDataView construction/destruction

CCollectDataView::CCollectDataView()
{
	// TODO: add construction code here
  printRect.SetRect(0, 0, 200, 300);
}

CCollectDataView::~CCollectDataView()
{
}

BOOL CCollectDataView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CCollectDataView drawing

void CCollectDataView::OnDraw(CDC* pDC)
{
	CCollectDataDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect client, page, rect;
	CSize size; 
	int len=pDoc->data->GetNumChannels();
	CFont *oldFont, titleFont, numberFont, smallFont;
  int i;

	if (!pDC->IsPrinting()) {
		pDC->GetWindow()->GetClientRect(client);
    page=client;
    //if (client.Width()>client.Height()) {
    //  page.bottom=int(page.Width()*8.5/11.0);
    //} else {
      page.bottom=int(page.Width()/8.5*11.0);
    //}
	  SetScrollSizes(MM_TEXT, page.Size());
    page.left=page.Width()/40;
  } else {
    page=printRect;
    page.left=page.right/8;
    page.right-=page.right/12;
    page.bottom-=page.Height()/10;
    page.top+=page.Height()/15;
  }

// title:
	titleFont.CreateFont(24*page.Width()/480, 0, 0, 0, FW_BOLD, FALSE, TRUE, 0, 
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	oldFont = (CFont*) pDC->SelectObject (&titleFont);
	CString buf;
	size=pDC->GetTextExtent(pDoc->heading);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, 
               int(0.25*size.cy)+page.top, pDoc->heading);
	page.top += int(1.5*size.cy);

// "fine print":
	smallFont.CreateFont(12*page.Width()/480, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	pDC->SelectObject (&smallFont);
	CData* data=pDoc->data;
	buf.Format ("Module name: '%s',   Control block:'%s',   Strobe delay: %3i.", 
		pDoc->moduleName, data->GetCBName(), data->GetStrobeDelay());
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(3.25*size.cy), buf);
	buf.Format ("V_thr: %5.3f V,   V_att: %5.3f V,   V_ref: %5.3f V,   V_cal: %5.3f V", 
		data->GetLLDacVoltage(data->GetLink()), data->GetDSPDacVoltage(0), 
		data->GetDSPDacVoltage(1), data->GetDSPDacVoltage(3));
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(2.25*size.cy), buf);
	buf.Format ("Bias Voltage: %5.0f V,   Alignment delay: %4i.", 
		data->GetBiasVoltage(), data->GetAlignmentDelay());
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(1.25*size.cy), buf);
	page.bottom -= int(5*size.cy);

	pDC->SelectObject (oldFont);
	numberFont.CreateFont(16*page.Width()/480, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	pDC->SelectObject (&numberFont);
// efficiency:
	float effi = 0.0;
	for (i=0; i<pDoc->data->GetNumChannels(); i++){
		if (!pDoc->badChannel[i]) effi+=pDoc->data->hits[i];
	}
	if (pDoc->data->GetTriggers()>0) {
		effi /= float(pDoc->data->GetNumChannels() * pDoc->data->GetTriggers());
	} else {
		effi = 0.0;
	}

	// Print the average efficiency.
	buf.Format ("Average efficiency: %f", effi);
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(2.25*size.cy), buf);

	// Also print the average multiplicity of the data.
	float multi = 0;
	for (i=0; i<pDoc->data->GetNumChannels(); i++) {
		if (!pDoc->badChannel[i]) multi += pDoc->data->multipleHits[i];
	}
	if (pDoc->data->GetTriggers() > 0) {
		multi /= float(pDoc->data->GetNumChannels() * pDoc->data->GetTriggers());
	} else {
		multi = 0.0;
	}

	buf.Format("Average multiplicity = %f", multi);
	size = pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(1.25*size.cy), buf);
	page.bottom -= int(3*size.cy);

	rect.SetRect(page.left, page.top, page.right, page.top+page.Height()*128/pDoc->data->GetNumChannels());
//	pDC->SelectObject (oldFont);

   for (i=0; i<pDoc->data->GetNumChannels()/128; i++){
	  graphRect[i] = DrawHisto (pDC, rect, pDoc->data->hits, i*128, 128);
	  rect.OffsetRect (0, rect.Height());
  }
	pDC->SelectObject (oldFont);
}

// CCollectDataView printing

BOOL CCollectDataView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCollectDataView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCollectDataView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


void CCollectDataView::OnInitialUpdate()
{
	CCollectDataDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
  
  CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 480;
	sizeTotal.cy = 800;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

// CCollectDataView diagnostics

#ifdef _DEBUG
void CCollectDataView::AssertValid() const
{
	CView::AssertValid();
}

void CCollectDataView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCollectDataDoc* CCollectDataView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCollectDataDoc)));
	return (CCollectDataDoc*)m_pDocument;
}
#endif //_DEBUG

// CCollectDataView message handlers

void CCollectDataView::MakeScale (unsigned int hitMax, int& upper, int& nticks, int& mticks)
{
	double range, a, r;
	int i, k;
	const int N=12;
	int y[N]      = {10, 12, 15, 16, 20, 25, 30, 40, 50, 60, 80, 100};
   int nTicks[N] = {10, 12, 15, 16, 20, 25, 15, 20, 25, 12, 16, 20};
   int mTicks[N] = { 5,  3,  3,  4,  4,  5,  3,  4,  5,  3,  4,  5};

	range = hitMax;
	a=log10(range);
	k=int(a);
	r=10.0*exp((a-k)*log(10.0)); // r=10 .. 99
	for (i=0; ((i<N)&&(r>=y[i])); i++);
	upper=int(y[i]*exp((k-1)*log(10.0)));
	nticks=nTicks[i];
	mticks=mTicks[i];
}




CRect CCollectDataView::DrawHisto(CDC* pDC, CRect rect, unsigned int* data, int start, int length)
{
	CCollectDataDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CString buf;
	int i;
	unsigned int hitMax;
	int ix, iy, y;
	float xmin, xmax, ymin, ymax;
	CSize size;
	int upper, nTicks, mTicks, ticksize;
	CPen *oldPen, newPen; // newPen is destroyed automatically.
	float sx, sy; // scales

	wid=rect.Width();
	hei=rect.Height();
	ticksize = 10*(wid+hei)/1200;

	hitMax=1; // find max hit number
	for (i=start; i<start+length; i++) {
		if ((!(pDoc->badChannel[i]))&&(data[i]>hitMax)) hitMax=data[i];
	}
	
	// get number of tick marks:
	MakeScale (hitMax, upper, nTicks, mTicks); 
	if (nTicks>upper) nTicks=upper; // no fractional tick marks
	if (mTicks>upper) mTicks=upper; // no fractional tick marks

	size=pDC->GetTextExtent("123gyj");
	// histogram size in screen coord.:
	ymin=rect.top+float(hei-1.5*size.cy); // 1.5 lines on bottom
	ymax=rect.top+float(1.5*size.cy);     // 1.5 lines on top
	xmin=0.0;

	//////////////////// y axis /////////////////////
	for (i=0; i<=mTicks; i++){
		buf.Format(" %i ", (upper*i)/mTicks);
		size=pDC->GetTextExtent(buf);
		if (xmin<size.cx) xmin=size.cx;
		iy=int(ymin+(ymax-ymin)/float(mTicks)*i-0.5*size.cy);
		pDC->TextOut(rect.left, iy, buf);
	}
	xmin=xmin+ticksize+rect.left;
	xmax=float(wid*0.975)+rect.left;

	for (i=0; i<=nTicks; i++){
		iy=int(ymin+(ymax-ymin)/float(nTicks)*i);
		pDC->MoveTo((int)xmin, iy);
		pDC->LineTo((int)xmin-ticksize/2, iy);
	}
	for (i=0; i<=mTicks; i++){
		iy=int(ymin+(ymax-ymin)/float(mTicks)*i);
		pDC->MoveTo((int)xmin, iy);
		pDC->LineTo((int)xmin-ticksize, iy);
	}
	/////////////////// Frame /////////////////////
	pDC->MoveTo((int)xmin, (int)ymin);
	pDC->LineTo((int)xmax+1, (int)ymin);
	pDC->LineTo((int)xmax+1, (int)ymax);
	pDC->LineTo((int)xmin, (int)ymax);
	pDC->LineTo((int)xmin, (int)ymin);

	CRect graphArea (xmin, ymax, xmax, ymin);

	size=pDC->GetTextExtent("Channel");
	pDC->TextOut(int(xmax)-2*size.cx, 
								hei-int(1.25*size.cy)+rect.top, "Channel");
	pDC->TextOut(3+rect.left, int(0.05*size.cy)+rect.top, "Hits");

	//////////////////// X Axis //////////////////		
	for (i=0; i<length/16; i++){
		ix=int(xmin+(xmax-xmin)/(length/16)*i);
		pDC->MoveTo(ix, (int)ymin);
		pDC->LineTo(ix, (int)ymin+ticksize/2+1);
	}		
	buf.Format("%i", start);
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(xmin-size.cx/2, ymin+int(0.25*size.cy), buf);
	buf.Format("%i", 127+start);
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(xmax-int(size.cx/2), ymin+int(0.25*size.cy), buf);
   ix=xmin;
	pDC->MoveTo(ix, (int)ymin);
	pDC->LineTo(ix, (int)ymin+ticksize+1);
   ix=xmax+1;
 	pDC->MoveTo(ix, (int)ymin);
	pDC->LineTo(ix, (int)ymin+ticksize+1);


	/////////////////// draw data /////////////////////////
	newPen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
	oldPen=pDC->SelectObject(&newPen);
	sy=-(ymax-ymin)/upper;
	sx=(xmax-xmin)/float(length);
	for (i=start; i<start+length; i++){
		y=int(sy*data[i]+0.5);
		if (y>upper) y = upper;
		ix=int(sx*(i-start)+xmin+0.5);
		pDC->Rectangle(ix, int(ymin)-y, int(sx*(i+1-start)+xmin+1.5), int(ymin)); 
	}
	pDC->SelectObject(oldPen);
	return graphArea; // save for MouseMove messages.
}

void CCollectDataView::OnSetheading() 
{
	CCollectDataDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CHeadingDlg dlg;

	dlg.heading=pDoc->heading;
	if (dlg.DoModal()!=IDOK) return;
	pDoc->heading=dlg.heading;
	pDoc->UpdateAllViews(NULL);
}


void CCollectDataView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	printRect=pInfo->m_rectDraw;
	CScrollView::OnPrint(pDC, pInfo);
}

void CCollectDataView::OnMouseMove(UINT nFlags, CPoint point) 
{

	CString str;
	int i;		// channel number
	int j;      // rect number
			 
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CStatusBar* pStatus= &pFrame->m_wndStatusBar;
	
	CCollectDataDoc* pDoc = GetDocument();
	CDC * thisDC = GetDC();
	CPoint scroll = GetScrollPosition( );
	point=point+scroll;
	if (pStatus) {
		// find rect:
		j=-1;
		for (int k=0; k<pDoc->data->GetNumChannels()/128; k++) {
			if (graphRect[k].PtInRect(point)) j=k;
		}

		if (j>=0){
			i=int(128*(point.x-graphRect[j].left)/(graphRect[j].Width())+0.5)+j*128;
			str.Format ("Channel = %3i, Hits = %i, Efficiency = %f",  i, 
							pDoc->data->hits[i], pDoc->data->hits[i]/float(pDoc->data->GetTriggers()));
		} else {
			str.Empty();
		}
		pStatus->SetPaneText (0, str);
	}
	CScrollView::OnMouseMove(nFlags, point);
}

void CCollectDataView::OnLButtonDown(UINT nFlags, CPoint point) 
{

	CString str;
	int i;		// channel number
	int j;      // rect number
			 
	
	CCollectDataDoc* pDoc = GetDocument();
	CDC * thisDC = GetDC();
	CPoint scroll = GetScrollPosition( );
	point=point+scroll;
	// find rect:
	j=-1;
	for (int k=0; k<pDoc->data->GetNumChannels()/128; k++) {
		if (graphRect[k].PtInRect(point)) j=k;
	}

	if (j>=0){
		i=int(128*(point.x-graphRect[j].left)/(graphRect[j].Width())+0.5)+j*128;
		CChannelDlg dlg;
		dlg.channel=i;
		dlg.hits=pDoc->data->hits[i];
		dlg.triggers=pDoc->data->GetTriggers();
		dlg.effi=pDoc->data->hits[i]/float(pDoc->data->GetTriggers());
		dlg.multi=pDoc->data->multipleHits[i];
		dlg.ratio=pDoc->data->multipleHits[i]/float(pDoc->data->hits[i]);
		dlg.bad=pDoc->badChannel[i];
		if (dlg.DoModal()==IDOK) {
			pDoc->badChannel[i]=dlg.bad;
		}
	} 

	CScrollView::OnLButtonDown(nFlags, point);
}
