// CDelayScanView.cpp : implementation of the CDelayScanView class
//

#include "stdafx.h"
#include <afxtempl.h>
#include "ALDAS.h"
#include "MainFrm.h"
#include <math.h>

#include "PlaceDoc.h"
#include "ScanDoc.h"
#include "Axis.h"
#include "DelayScanDoc.h"
#include "DelayScanView.h"
#include "HeadingDlg.h"
#include "Data.h"
#include "FitResultDlg.h"
#include "Module.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDelayScanView

IMPLEMENT_DYNCREATE(CDelayScanView, CScrollView)

BEGIN_MESSAGE_MAP(CDelayScanView, CScrollView)
	//{{AFX_MSG_MAP(CDelayScanView)
	ON_COMMAND(ID_SETHEADING, OnSetheading)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CDelayScanView construction/destruction

CDelayScanView::CDelayScanView()
{
	// TODO: add construction code here
  printRect.SetRect(0, 0, 200, 300);
}

CDelayScanView::~CDelayScanView()
{
}

BOOL CDelayScanView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CDelayScanView drawing

void CDelayScanView::OnDraw(CDC* pDC)
{
	int i;
	CDelayScanDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect client, rect, page;
	CSize size; 
	CString buf;
	CData *data;
	int len = pDoc->numPoints;
	CFont *oldFont, titleFont, numberFont, smallFont;

	if (!pDC->IsPrinting()) {
		pDC->GetWindow()->GetClientRect(client);
		page=client;
      page.bottom=int(page.Width()/8.5*11.0);
		SetScrollSizes(MM_TEXT, page.Size());
		page.left=page.Width()/40;
	} else {
		 page=printRect;
		 page.left=page.right/8;
		 page.right-=page.right/12;
		 page.bottom-=page.Height()/10;
		 page.top+=page.Height()/15;
	}

// TITLE:
	titleFont.CreateFont(24*page.Width()/480, 0, 0, 0, FW_BOLD, FALSE, TRUE, 0, 
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	oldFont = (CFont*) pDC->SelectObject (&titleFont);
	size=pDC->GetTextExtent(pDoc->heading);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, 
               int(0.25*size.cy)+page.top, pDoc->heading);
	page.top += int(1.5*size.cy);

// "fine print":
	smallFont.CreateFont(12*page.Width()/480, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	pDC->SelectObject (&smallFont);
	data=pDoc->dataArray[0];
	buf.Format ("Module name: '%s',   Control block:'%s',   Strobe delay: %3i.", 
		pDoc->moduleName, data->GetCBName(), data->GetStrobeDelay());
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(3.25*size.cy), buf);
	buf.Format ("V_thr: %5.3f V,   V_att: %5.3f V,   V_ref: %5.3f V,   V_cal: %5.3f V", 
		data->GetLLDacVoltage(data->GetLink()), data->GetDSPDacVoltage(0), 
		data->GetDSPDacVoltage(1), data->GetDSPDacVoltage(3));
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(2.25*size.cy), buf);
	buf.Format ("Bias Voltage: %5.0f V,   Alignment delay: %4i.", 
		data->GetBiasVoltage(), data->GetAlignmentDelay());
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, page.bottom-int(1.25*size.cy), buf);
	page.bottom -= int(5*size.cy);
/*
	// Write the average multiplicity at the bottom of the document window.
			// Now write the ratio in the rectangle.
		pDC->SelectObject(numberFont);
		buf.Format("Single:Double = %3.3f", pDoc->hitRatio);
		pDC->TextOut(newRect.left+20, newRect.bottom - 50, buf);
*/

//	graphs:
	if (pDoc->numPoints>0) {
		rect.SetRect(page.left, page.top, page.right, page.top+page.Height());
		pDC->SelectObject (oldFont);
		numberFont.CreateFont(14*rect.Width()/480, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
						ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
						DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
		oldFont = (CFont*) pDC->SelectObject (&numberFont);


		pDoc->axis[0]->PlotVersus (pDC, rect, pDoc->axis[1]);
	}
	pDC->SelectObject (oldFont);
	rect.SetRect(page.left, page.top, page.right, page.top+page.Height()*0.1);
}

// CDelayScanView printing

BOOL CDelayScanView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDelayScanView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDelayScanView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


void CDelayScanView::OnInitialUpdate()
{
	CDelayScanDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
  
  CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 480;
	sizeTotal.cy = 800;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

// CDelayScanView diagnostics

#ifdef _DEBUG
void CDelayScanView::AssertValid() const
{
	CView::AssertValid();
}

void CDelayScanView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDelayScanDoc* CDelayScanView::GetDocument() // non-debug version is inline
{
//	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(DelayScanDoc)));
	return (CDelayScanDoc*)m_pDocument;
}
#endif //_DEBUG

// CDelayScanView message handlers




void CDelayScanView::OnSetheading() 
{
	CDelayScanDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CHeadingDlg dlg;

	dlg.heading=pDoc->heading;
	if (dlg.DoModal()!=IDOK) return;
	pDoc->heading=dlg.heading;
	pDoc->SetModifiedFlag(TRUE);
	pDoc->UpdateAllViews(NULL);
}


void CDelayScanView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	printRect=pInfo->m_rectDraw;
	CScrollView::OnPrint(pDC, pInfo);
}


void CDelayScanView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CString str;
	char pm=177; // plus/minus char
	char sq=178; // square char
	int i;		// channel number
					// true if cursor is inside the graph rectangle.
			 
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CStatusBar* pStatus= &pFrame->m_wndStatusBar;
	
	CDelayScanDoc* pDoc = GetDocument();
	CDC * thisDC = GetDC();
	CPoint scroll = GetScrollPosition( );
	point=point+scroll;
	if (pStatus) {
		i=pDoc->axis[1]->GetChannelNumber(point);
		if (i>=0 && pDoc->axis[1]->CursorInsideGraphRect(point)) {
			str.Format ("Alignment delay = %f, Efficiency = %f %c %f",  
							pDoc->axis[1]->GetData()[i],
							pDoc->axis[0]->GetData()[i], pm, pDoc->axis[0]->GetError()[i]);
		} else {
			str.Empty();
		}
		pStatus->SetPaneText (0, str);
	}
	CScrollView::OnMouseMove(nFlags, point);
}


void CDelayScanView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int i,j; 
//	float triggers; 
	CDelayScanDoc* pDoc = GetDocument();
	float *data, *error, *chi2;
	CAxis effi;

	CPoint scroll = GetScrollPosition( );
	point=point+scroll;

	i=pDoc->axis[1]->GetChannelNumber(point);
	if ((i>=0)&& pDoc->axis[1]->CursorInsideGraphRect(point)) {
		// get the data to be displayed:
		data=new float[pDoc->numChannels];
		error=new float[pDoc->numChannels];
		chi2=new float[pDoc->numChannels];

		for (j=0; j<pDoc->numChannels; j++){
			data[j]=pDoc->dataArray[i]->hits[j]/float(pDoc->dataArray[i]->GetTriggers());
			error[j]=sqrt(data[j]*(1.0-data[j])/float(pDoc->dataArray[i]->GetTriggers()));
			chi2[j]=0.0;
		}
		chi2[253]=-1.0; // FIXME: store bad channel list in document
		chi2[254]=-1.0; // FIXME: store bad channel list in document
		chi2[255]=-1.0; // FIXME: store bad channel list in document
		effi = CAxis("Efficiency", pDoc->numChannels, data, error, chi2);
		CFitResultDlg dlg;
		dlg.Init(&effi, NULL, pDoc->axis[0]->GetData()[i], pDoc->axis[0]->GetError()[i]);
		if (dlg.DoModal()==IDOK) {
//			pDoc->badChannel[i] = dlg.badChannel;
		}
		delete [] data;
		delete [] error;
		delete [] chi2;
	}
	CScrollView::OnLButtonDown(nFlags, point);
}
