// CollectDataView.cpp : implementation of the CGetDataExternalTrigsView class
//

#include "stdafx.h"
#include "ALDAS.h"
#include <math.h>

#include "GetDataExternalTrigsDoc.h"
#include "GetDataExternalTrigsView.h"
#include "CollectDataDoc.h"
#include "HeadingDlg.h"
#include "Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CGetDataExternalTrigsView

IMPLEMENT_DYNCREATE(CGetDataExternalTrigsView, CScrollView)

BEGIN_MESSAGE_MAP(CGetDataExternalTrigsView, CScrollView)
	//{{AFX_MSG_MAP(CGetDataExternalTrigsView)
	ON_COMMAND(ID_SETHEADING, OnSetheading)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CGetDataExternalTrigsView construction/destruction

CGetDataExternalTrigsView::CGetDataExternalTrigsView()
{
	// TODO: add construction code here
  printRect.SetRect(0, 0, 200, 300);
}

CGetDataExternalTrigsView::~CGetDataExternalTrigsView()
{
}

BOOL CGetDataExternalTrigsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CGetDataExternalTrigsView drawing

/*CCollectDataDoc* CGetDataExternalTrigsView::GetDocument() { 
	return (CCollectDataDoc*) m_pDocument;
}*/

void CGetDataExternalTrigsView::OnDraw(CDC* pDC)
{
	CGetDataExternalTrigsDoc * pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect client, rect, page;
	CSize size; 
	int len=pDoc->data->GetNumChannels();
	CFont *oldFont, titleFont, numberFont;
  int i;

	if (!pDC->IsPrinting()) {
		pDC->GetWindow()->GetClientRect(client);
    page=client;
    //if (client.Width()>client.Height()) {
    //  page.bottom=int(page.Width()*8.5/11.0);
    //} else {
      page.bottom=int(page.Width()/8.5*11.0);
    //}
	  SetScrollSizes(MM_TEXT, page.Size());
    page.left=page.Width()/40;
  } else {
    page=printRect;
    page.left=page.right/8;
    page.right-=page.right/12;
    page.bottom-=page.Height()/10;
    page.top+=page.Height()/15;
  }

	titleFont.CreateFont(24*page.Width()/480, 0, 0, 0, FW_BOLD, FALSE, TRUE, 0, 
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	oldFont = (CFont*) pDC->SelectObject (&titleFont);
	CString buf;
	size=pDC->GetTextExtent(pDoc->heading);
	pDC->TextOut(page.Width()/2-size.cx/2+page.left, 
               int(0.25*size.cy)+page.top, pDoc->heading);
	page.top += int(1.5*size.cy);

	rect.SetRect(page.left, page.top, page.right, page.top+page.Height()*128/pDoc->data->GetNumChannels());
	pDC->SelectObject (oldFont);
	numberFont.CreateFont(14*rect.Width()/480, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0, 
					ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
					DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	oldFont = (CFont*) pDC->SelectObject (&numberFont);

  for (i=0; i<pDoc->data->GetNumChannels(); i+=128){
	  DrawHisto (pDC, rect, pDoc->data->hits+i, i, 128);
	  rect.OffsetRect (0, rect.Height());
  }
	pDC->SelectObject (oldFont);
}

// CGetDataExternalTrigsView printing

BOOL CGetDataExternalTrigsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGetDataExternalTrigsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGetDataExternalTrigsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


void CGetDataExternalTrigsView::OnInitialUpdate()
{
	CGetDataExternalTrigsDoc * pDoc = GetDocument();
	ASSERT_VALID(pDoc);
  
  CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 480;
	sizeTotal.cy = 800;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

// CGetDataExternalTrigsView diagnostics

#ifdef _DEBUG
void CGetDataExternalTrigsView::AssertValid() const
{
	CView::AssertValid();
}

void CGetDataExternalTrigsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

CGetDataExternalTrigsDoc* CGetDataExternalTrigsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGetDataExternalTrigsDoc)));
	return (CGetDataExternalTrigsDoc*)m_pDocument;
}

// CGetDataExternalTrigsView message handlers

void CGetDataExternalTrigsView::MakeScale (unsigned int hitMax, int& upper, int& nticks, int& mticks)
{
	double range, a, r;
	int i, k;
	const int N=12;
	int y[N]      = {10, 12, 15, 16, 20, 25, 30, 40, 50, 60, 80, 100};
   int nTicks[N] = {10, 12, 15, 16, 20, 25, 15, 20, 25, 12, 16, 20};
   int mTicks[N] = { 5,  3,  3,  4,  4,  5,  3,  4,  5,  3,  4,  5};

	range = hitMax;
	a=log10(range);
	k=int(a);
	r=10.0*exp((a-k)*log(10.0)); // r=10 .. 99
	for (i=0; ((i<N)&&(r>=y[i])); i++);
	upper=int(y[i]*exp((k-1)*log(10.0)));
	nticks=nTicks[i];
	mticks=mTicks[i];
}




void CGetDataExternalTrigsView::DrawHisto(CDC* pDC, CRect rect, unsigned int* data, int start, int length)
{
	CString buf;
	int i;
	unsigned int hitMax;
	int ix, iy, y;
	float xmin, xmax, ymin, ymax;
	CSize size;
	int upper, nTicks, mTicks, ticksize;
	CPen *oldPen, newPen; // newPen is destroyed automatically.
	float sx, sy; // scales

	wid=rect.Width();
	hei=rect.Height();
	ticksize = 10*(wid+hei)/1200;

	hitMax=1; // find max hit number
	for (i=0; i<length; i++) if (data[i]>hitMax) hitMax=data[i];
	
	// get number of tick marks:
	MakeScale (hitMax, upper, nTicks, mTicks); 
	if (nTicks>upper) nTicks=upper; // no fractional tick marks
	if (mTicks>upper) mTicks=upper; // no fractional tick marks

	size=pDC->GetTextExtent("123gyj");
	// histogram size in screen coord.:
	ymin=rect.top+float(hei-1.5*size.cy); // 1.5 lines on bottom
	ymax=rect.top+float(1.5*size.cy);     // 1.5 lines on top
	xmin=0.0;

	//////////////////// y axis /////////////////////
	for (i=0; i<=mTicks; i++){
		buf.Format(" %i ", (upper*i)/mTicks);
		size=pDC->GetTextExtent(buf);
		if (xmin<size.cx) xmin=size.cx;
		iy=int(ymin+(ymax-ymin)/float(mTicks)*i-0.5*size.cy);
		pDC->TextOut(rect.left, iy, buf);
	}
	xmin=xmin+ticksize+rect.left;
	xmax=float(wid*0.975)+rect.left;

	for (i=0; i<=nTicks; i++){
		iy=int(ymin+(ymax-ymin)/float(nTicks)*i);
		pDC->MoveTo((int)xmin, iy);
		pDC->LineTo((int)xmin-ticksize/2, iy);
	}
	for (i=0; i<=mTicks; i++){
		iy=int(ymin+(ymax-ymin)/float(mTicks)*i);
		pDC->MoveTo((int)xmin, iy);
		pDC->LineTo((int)xmin-ticksize, iy);
	}
	/////////////////// Frame /////////////////////
	pDC->MoveTo((int)xmin, (int)ymin);
	pDC->LineTo((int)xmax+1, (int)ymin);
	pDC->LineTo((int)xmax+1, (int)ymax);
	pDC->LineTo((int)xmin, (int)ymax);
	pDC->LineTo((int)xmin, (int)ymin);

	size=pDC->GetTextExtent("Channel");
	pDC->TextOut(int(xmax)-2*size.cx, 
								hei-int(1.25*size.cy)+rect.top, "Channel");
	pDC->TextOut(3+rect.left, int(0.05*size.cy)+rect.top, "Hits");

	//////////////////// X Axis //////////////////		
	for (i=0; i<length/16; i++){
		ix=int(xmin+(xmax-xmin)/(length/16)*i);
		pDC->MoveTo(ix, (int)ymin);
		pDC->LineTo(ix, (int)ymin+ticksize/2+1);
	}		
	buf.Format("%i", start);
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(xmin-size.cx/2, ymin+int(0.25*size.cy), buf);
	buf.Format("%i", 128+start);
	size=pDC->GetTextExtent(buf);
	pDC->TextOut(xmax-int(size.cx/2), ymin+int(0.25*size.cy), buf);
  ix=xmin;
	pDC->MoveTo(ix, (int)ymin);
	pDC->LineTo(ix, (int)ymin+ticksize+1);
  ix=xmax+1;
	pDC->MoveTo(ix, (int)ymin);
	pDC->LineTo(ix, (int)ymin+ticksize+1);


	/////////////////// draw data /////////////////////////
	newPen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
	oldPen=pDC->SelectObject(&newPen);
	sy=-(ymax-ymin)/upper;
	sx=(xmax-xmin)/float(length);
	for (i=0; i<length; i++){
		y=int(sy*data[i]+0.5);  // If data[i] = NO HIT then don't draw the rect!
		ix=int(sx*i+xmin+0.5);
		pDC->Rectangle(ix, int(ymin)-y, int(sx*(i+1)+xmin+1.5), int(ymin)); 
	}
	pDC->SelectObject(oldPen);
}

void CGetDataExternalTrigsView::OnSetheading() 
{
	CGetDataExternalTrigsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CHeadingDlg dlg;

	dlg.heading=pDoc->heading;
	if (dlg.DoModal()!=IDOK) return;
	pDoc->heading=dlg.heading;
	pDoc->UpdateAllViews(NULL);
}


void CGetDataExternalTrigsView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	printRect=pInfo->m_rectDraw;
	CScrollView::OnPrint(pDC, pInfo);
}
