// ScanDoc.h : header file
//
// CScanDoc document


class CArray;
class CData;
class CAxis;
//class Hybrid;
class Module;
class HAL;

class CScanDoc : public CPlaceDoc
{
friend class CScanView;
//friend class CHistogramView;

protected:
	CScanDoc();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CScanDoc)

// Attributes
public:
	BOOL* badChannel;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScanDoc)
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CScanDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	Module * GetModule();
	int numChi2;
	CString moduleName;
	int numParam;
	int numPoints;
	CString heading;
	UINT link;
	int trig;
	int numChannels;
	CArray<CData *, CData *> dataArray;

	//{{AFX_MSG(CScanDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CArray<CAxis*, CAxis*> axis;
	CArray<float*, float*> par;
	CArray<float*, float*> err;
	CArray<float*, float*> chi2;
protected:
	Module * module;
	HAL * hal;
private:
	// Memory diagnostic objects.
/*	CMemoryState * oldMemState;
	CMemoryState * newMemState;
	CMemoryState * diffMemState;*/
};
