// StrobeScanView.cpp : implementation file
//
#include "stdafx.h"
#include <afxtempl.h>
#include "ALDAS.h"
#include "MainFrm.h"
#include <math.h>

#include "PlaceDoc.h"
#include "ScanDoc.h"
#include "Axis.h"
#include "ScanView.h"
#include "HeadingDlg.h"
#include "NoiseFitDlg.h"
#include "Data.h"
#include "FitFunction.h"
#include "StrobeScanView.h"
#include "StrobeScanDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CStrobeScanView

IMPLEMENT_DYNCREATE(CStrobeScanView, CScrollView)

CStrobeScanView::CStrobeScanView()
{
}

CStrobeScanView::~CStrobeScanView()
{
}


BEGIN_MESSAGE_MAP(CStrobeScanView, CScrollView)
	//{{AFX_MSG_MAP(CStrobeScanView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_HISTOGRAM_VIEW, OnHistogramView)
	ON_COMMAND(ID_LINE_FIT_VIEW, OnLineFitView)
	ON_UPDATE_COMMAND_UI(ID_HISTOGRAM_VIEW, OnUpdateHistogramView)
	ON_UPDATE_COMMAND_UI(ID_LINE_FIT_VIEW, OnUpdateLineFitView)
	ON_COMMAND(ID_SETHEADING, OnSetheading)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CStrobeScanView diagnostics

#ifdef _DEBUG
void CStrobeScanView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CStrobeScanView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CStrobeScanDoc* CStrobeScanView::GetDocument() // non-debug version is inline
{
//	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScanDoc)));
	return (CStrobeScanDoc*)m_pDocument;
}
#endif //_DEBUG

// CStrobeScanView message handlers

void CStrobeScanView::OnMouseMove(UINT nFlags, CPoint point) 
{	
	CScanView::OnMouseMove(nFlags, point);
}

void CStrobeScanView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int ch; // channel number
	int i, link;
	float triggers;
	CStrobeScanDoc* pDoc = GetDocument();
	CAxis *xAxis, *yAxis;

	if (viewMode == LineFitView) {
		ch=pDoc->axis[0]->GetChannelNumber(point);
		link = pDoc->dataArray[0]->GetLink();
		if (ch>=0) {
			// get the rawdata to be displayed:
			xTemp=new float[pDoc->numPoints];
			yTemp=new float[pDoc->numPoints];
			eTemp=new float[pDoc->numPoints];
			for (i=0; i<pDoc->numPoints; i++) {
				triggers=pDoc->dataArray[i]->GetTriggers();
				if (triggers<=0) triggers=1.0;
				yTemp[i]=pDoc->dataArray[i]->hits[ch]/triggers;
				eTemp[i]=sqrt(yTemp[i]*(1-yTemp[i])/triggers);
				xTemp[i]=pDoc->dataArray[i]->GetStrobeDelay();
			}
			yAxis=new CAxis("Efficiency", pDoc->numPoints, yTemp, eTemp, &pDoc->axis[0]->GetChiSquare()[ch]);
			xAxis=new CAxis("Delay", pDoc->numPoints, xTemp, NULL, &pDoc->axis[0]->GetChiSquare()[ch]);

			CNoiseFitDlg dlg;
			CFitFunction* func = new CFitFunction( StepType, pDoc->axis[0]->GetData()[ch], pDoc->axis[1]->GetData()[ch], 20.0);
			dlg.Init(pDoc->axis[0], pDoc->axis[1], ch, pDoc->badChannel, xAxis, yAxis, func);
			dlg.boxTitle = "Strobe Delay Fit";
			dlg.DoModal();
			if (dlg.DoModal()==IDOK) {
				pDoc->badChannel[i] = dlg.badChannelCheck;
			}
			delete[] xTemp;
			delete[] yTemp;
			delete[] eTemp;
			delete func;

			delete xAxis;
			delete yAxis;
			xAxis=NULL;
			yAxis=NULL;
			xTemp=NULL;
			yTemp=NULL;
			eTemp=NULL;
		}
	}
	CScrollView::OnLButtonDown(nFlags, point);
}

void CStrobeScanView::OnHistogramView() 
{
	CScanView::OnHistogramView();
}

void CStrobeScanView::OnLineFitView() 
{
	CScanView::OnLineFitView();	
}

void CStrobeScanView::OnUpdateHistogramView(CCmdUI* pCmdUI) 
{
	CScanView::OnUpdateHistogramView(pCmdUI);
}

void CStrobeScanView::OnUpdateLineFitView(CCmdUI* pCmdUI) 
{
	CScanView::OnUpdateLineFitView(pCmdUI);
}

void CStrobeScanView::OnSetheading() 
{
	CScanView::OnSetheading();	
}
