//Header file for utility.cpp:
/* The routines listed below are used by many of the Recipes.  Most of the routines
are used to allocate and deallocate memory for vectors and matricies, as explained in
detail in sec. 1.2, p. 15-20.  All memory allocation for Numerical Recipes functions
are handled using these functions.  */

/* Taken from appendix D, pp. 705-709. */



void nrerror (char  *error_text);

float *vector (int nl, int nh);

void free_vector(float *v, int nl, int nh);

int *ivector (int nl, int nh);

void free_ivector(int *v, int nl, int nh);

float **matrix(int nrl, int nrh, int ncl, int nch);

void free_matrix (float **m, int nrl, int nrh, int ncl, int nch);
