/* error function.  Requires module gamma.c.  Taken from Chapter 6.2, pp. 175 */
#include "stdafx.h"

#include <math.h>
//#include <stdio.h>
//#include <stdlib.h>

float erf(float x)
//double x;
/* returns the error function erf(x) = Integral[E^(-t^2), {t, 0, x}] * 2/Sqrt[Pi] */
{
   float gammp(float, float);
   
   return x < 0.0 ? -gammp(0.5,x*x) : gammp(0.5,x*x);
}

float erfc(float x)
//double x;
/* returns the complementary error function erfc(x). */
{
	float gammp(float, float),gammq(float, float);
	
	return x<0.0 ? 1.0+gammp(0.5,x*x) : gammq(0.5,x*x);
}

float erfcc(float x)
//double x;
/* Returns the complementary error function erfc(x) with fractional error everywhere
less than 1.2e-7 */
{
	float t,z,ans;
	z=fabs(x);
	t=1.0/(1.0+0.5*z);
	ans=t*exp(-z*z-1.26551223+t*(1.00002368+t*(0.37409196+t*(0.09678418+
		t*(-0.18628806+t*(0.27886807+t*(-1.13520398+t*(1.48851587+
		t*(-0.82215223+t*0.17087277)))))))));
	return x >= 0.0 ? ans : 2.0-ans;
}