/**********************************************************************/
/* strips.h, ucsc.h                                                   */
/**********************************************************************/
/*                          ACTION_ID:                                */
/**********************************************************************/

/**********************************************************************/
/* us_action_id.h                                                     */
/*                USER MESSAGES: DEFINITIONS OF action_id             */
/*                strips: action_id 200-299                           */
/*                pixels: action_id 100-199                           */
/**********************************************************************/
#define LOAD_CONTROL_BLOCK 200
#define EXECUTE_CONTROL_BLOCK 201
#define GET_DET_STATUS        202
#define DET_STATUS            203
#define SET_STROBE_DELAY      204
#define SET_COUNTER_VAL       205
#define SET_LL_DAC            206
#define GET_LL_STATUS         207
#define LL_STATUS             208
#define LOAD_EXE_CTR_BLK      209
#define SET_TIMEOUT           210
#define RESET_FIFOS           211
#define DIS_ENABLE_LINK       212
#define RESET_DETECTORS       213
/**********************************************************************/
/* strips_error_codes.h                                               */
/*                    ERROR CODE DEFINITIONS                          */
/**********************************************************************/
/* fatal errors:     reported by message fatal_error                  */

/* other errors:     reported by message error_report                 */

#define BLOCK_TOO_LONG         200    /* control block too long       */
#define INVALID_BLOCK_NUMBER   201    /* valid blocks: 0-3            */
#define INVALID_COUNTER_VALUE  210
#define INVALID_DELAY_VALUE    211
#define TIMEOUT                212   
#define TOO_FEW_PACKETS        213    /* read_packets did not receive */
                                      /* expected number of packets   */
                                      /* within time limit given by   */
                                      /* det_read_timeout             */

#ifdef I_AM_DSP

/**********************************************************************/
/* us_defaults.h                                                      */
/*                    DEFAULTS                                        */
/**********************************************************************/
#define RUN_MODE    EOB_TRANSFER /* run-mode                          */
#define TRIG_PULSES       1      /* trigger accepts/external trigger  */
#define TRIG_DELAY1      80      /* delay for trigger alignment fifo 1*/
#define TRIG_DELAY2      80      /* delay for trigger alignment fifo 2*/
#define VOLTAGE           0      /* DSP-DAC voltage                   */ 
/**********************************************************************/
/* add other default values to be set in set_defaults()               */
/**********************************************************************/
#define STROBE_DELAY      0      /* strobe delay                      */
#define COUNTER_VAL       99     /* input fifo control counter value  */
#define LL_VOLTAGE        0      /* LL-DAC voltage                    */ 
#define DET_READ_TIMEOUT  1000   /* timeout for reading packets       */
#define GEN_TIMEOUT       0      /* general timeout, not used yet     */


#endif

