#ifndef _sys_priv_h
#define _sys_priv_h

/* sys_priv.h */
/* privcomm.h */

/* private communication constants and function prototypes */

/* public  == for use by the host system code and/or by the DSP system code */
/* private == for use by the developers of the communication system only */


/* This file has three parts:  I, II, III.  See below. */


/* I. Items here are for use by software running in the host or in the DSP. */


#define MIMPORT		0
#define MEXPORT		1
#define DAV		2
#define ACK		3
#define EOM		4
#define ABORT		5


#define MTU 		1024	
#define LOOKUPS		3


typedef struct {
  int id;
  int timestamp;
  int return_add;
  int size;
} t_head;

typedef struct {
  t_head header;
  UINT message[MTU];
} transport;

typedef struct {
  u_int32 boot[16];         /* reserved for DSP's system download code */
  volatile int signals;
  transport packet ;
  volatile int flags[NUM_FLAGS];
} dpr;

/* II. Items here are for use by software running in the host. */

#define MESS_TIMEOUT   (1000000)
#define PORT_OFFSET    DPRAM_SIZE

#define TMESSID()	io_base->packet.header.id
#define TTIME()	io_base->packet.header.timestamp
#define	TRETURN()	io_base->packet.header.return_add
#define TSIZE()	io_base->packet.header.size
#define FLAG(y)	io_base->flags[y]

#define DO_T_HEAD()	io_base->packet.header.id = mess_id; \
                        io_base->packet.header.timestamp = time; \
                        io_base->packet.header.return_add = iam; \
                        io_base->packet.header.size = remain

#define MCIW(x)		x->ciw
#define MSIZE(x)	x->len
#define MDEST(x)        x->dsp

#endif _sys_priv_h