//int MessArea[MESS_BLOCKSIZE];
int dsp_status[NUM_CHAN];
int verb_flag;

/* functions in this file */

int init_dsps( int dsp_min, int dsp_max, char* path );		/* reset and initialize DSP's, send system */
void send_system ( int dsp_min, int dsp_max, char *path );	/* download system to DSP's */
void depart();												/* close files, etc., before leaving send_system() */
void check_final( int dsp_no );								/* check if download completed ok */
void prep_dsp( int dsp_no );								/* prepare DSP for system download */
int  timed_wait( u_int32* var1, u_int32 var2 );				/* wait until *var1 == var2  or timeout */
int  prep_file( char *path );								/* return 0 if everything went ok, else -1 */
void send_page( int dsp_no, u_int32 *page_data );			/* send page of system from host RAM to DSP */
void log_timeout( int dsp_no, char *err_mess );				/* log timeout error */
int  get_page( u_int32 *page );								/* get page of system file into host's RAM */
int  check_word_0( u_int32 w );								/* check that word 0 of system file is 0x20 */
int  check_addr( u_int32 w );								/* check that address in system file is valid */
int  check_blck_size( u_int32 w );							/* check that block size in system file is valid */
int  get_word( u_int32 *word );								/* return GW_ERR, GW_EOF, or GW_OK */
void log_err( int err_code, char *err_mess );				/* print out errors */
void log_boot( int dsp_no );								/* print out contents of boot structure */
void init_dpram( int dsp_no );								/* zero all of DPRAM except host_state */
void reset_dsp( int dsp_no );								/* reset DSP and perform minimal initializations */
void depart(void);
long simp_clock(void);

/* FORM_bpt(dsp_no) forms a pointer to the specified DSP's boot structure */
#define FORM_bpt(dsp_no) \
  struct boot_dpr *bpt;  \
  bpt = (struct boot_dpr*) dsp_base( dsp_no );

extern int dsp_status[];		/* download status of each DSP */

int  down_errs;			/* count of errors encountered during download */
int  sysf_state;		/* host's state w.r.t. reading the system file */
long sysf_words;		/* number of words read from the system file   */
long sysf_blk_size;		/* size  of current block in system file */
long sysf_blk_index;	/* index in current block in system file */
FILE*  fpt;				/* pointer to system file */


#define SS_START       (0)		/* state of system file */
#define SS_WORD_0      (1)
#define SS_WORD_1      (2)
#define SS_BLK_SIZE    (3)
#define SS_BLK_DEST    (4)
#define SS_BLK_DATA    (5)
#define SS_DATA        (6)
#define SS_END         (7)

									/* these values are used for error checking */
#define MAX_SYSTEM_SIZE  (250000)	/* max system size in u_int32's */
#define MAX_SYSTEM_BLCK  (250000)	/* max size of block in system file */
#define MIN_SYSTEM_ADDR  (0x809800)	/* min address of block in system file */
#define MAX_SYSTEM_ADDR  (0x93ffff)	/* max address of block in system file */
