#include "stdafx.h"

#include "ALDAS.h"

#include "llcard.h"
#include "module.h"
#include "lbic.h"
#include "data.h"

extern CALDASApp theApp;

LBIC::LBIC() {
	name = "Strips 1";
	CalculateEventLength();
}

LBIC::~LBIC() {
}

// Before we can take data with an LBIC module, we must reset it.
void LBIC::InitializeModule() {
	if (llCard) {
		llCard->LoadControlBlock(3, theApp.cbHacReset);
		llCard->ExecuteControlBlock(3, 5);
	}
}

void LBIC::CalculateEventLength() {
	int tmp = 25+numChannels+9*(numChannels/128-1);
	if (tmp%8 == 0) {
		counterValue = tmp/8;
	} else {
		counterValue = tmp/8+1;
	} 
	if (tmp%32 == 0) {
		eventLength=tmp/32;
	} else {
		eventLength=tmp/32+1;
	} 
}

void LBIC::DecodeData(CData * data, UINT * mess) {
//	CalculateEventLength();
//	int * hitArray = new int [numChannels];

	const int NHEAD_WORDS=26;
	const int SKIP_CHIP_BOUNDARY=9;
	unsigned int  bit, word, shift, i, events;
	int  hitsFound;

	events=(mess[1]-12)/eventLength;
	TRACE ("%i, %i, %i\n", events, (mess[1]-12),eventLength);

	mess += 12;     // skip header, go to the beginning of hit data 

	hitsFound = 0;
	int maxHits = 0;
	int multipleHit = 0;
	for (i=0; i<events; i++) {
		multipleHit = 0;
		for (UINT chan = 0; chan < numChannels; chan++ )  {
		  // calculate the bit number for this channel:
			bit = NHEAD_WORDS + chan + (chan/128) * SKIP_CHIP_BOUNDARY;
			word  = bit / 32;
			shift = 31 - bit % 32;

			if (((mess[word] >> shift) & 0x1) == hitPolarity)  {

				// If the previous channel contained a hit, then mark it as a 'multipleHit'
				if (multipleHit > 0) {
					data->multipleHits[chan] ++;
//					data->multipleHits[chan-1] ++;
//					TRACE("double hit found in channel %i\n", chan);
//					multipleHit = 0;
				}
				multipleHit ++;

				// Also increment the single hit counter.
				data->hits[chan] ++;
				if (data->hits[chan] > maxHits)	maxHits = data->hits[chan];
				hitsFound++;
			} else {
				multipleHit = 0;
			}
		}
		mess+=eventLength;
	}
	int oldTrigs = data->GetTriggers();
	data->SetTriggers(events+oldTrigs);
}